SoCylinder Class Reference
Node Classes

The SoCylinder class is for rendering cylinder shapes. More...

`#include <Inventor/nodes/SoCylinder.h>`

Inheritance diagram for SoCylinder:

## Public Types

enum | Part { SIDES = 0x1 , TOP = 0x2 , BOTTOM = 0x4 , ALL = SIDES|TOP|BOTTOM }
Public Types inherited from SoShape
enum | TriangleShape { TRIANGLE_STRIP , TRIANGLE_FAN , TRIANGLES , POLYGON , QUADS , QUAD_STRIP , POINTS , LINES , LINE_STRIP }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoCylinder (void)
void | addPart (SoCylinder::Part part)
void | removePart (SoCylinder::Part part)
SbBool | hasPart (SoCylinder::Part part) const
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | GLRender (SoGLRenderAction *action)
Public Member Functions inherited from SoShape
virtual SbBool | affectsState (void) const
virtual void | notify (SoNotList *nl)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | callback (SoCallbackAction *action)
const SoBoundingBoxCache * | getBoundingBoxCache (void) const
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoShape
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | getScreenSize (SoState *const state, const SbBox3f &boundingbox, SbVec2s &rectsize)
static float | getDecimatedComplexity (SoState *state, float complexity)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFFloat | radius
SoSFFloat | height
SoSFBitMask | parts

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoCylinder ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
Protected Member Functions inherited from SoShape
| SoShape (void)
virtual | ~SoShape ()
float | getComplexityValue (SoAction *action)
virtual SbBool | shouldGLRender (SoGLRenderAction *action)
void | beginSolidShape (SoGLRenderAction *action)
void | endSolidShape (SoGLRenderAction *action)
void | GLRenderBoundingBox (SoGLRenderAction *action)
SbBool | shouldPrimitiveCount (SoGetPrimitiveCountAction *action)
SbBool | shouldRayPick (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action)
void | computeObjectSpaceRay (SoRayPickAction *const action, const SbMatrix &matrix)
virtual SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)
virtual SoDetail * | createLineSegmentDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, SoPickedPoint *pp)
virtual SoDetail * | createPointDetail (SoRayPickAction *action, const SoPrimitiveVertex *v, SoPickedPoint *pp)
void | invokeTriangleCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2, const SoPrimitiveVertex *const v3)
void | invokeLineSegmentCallbacks (SoAction *const action, const SoPrimitiveVertex *const v1, const SoPrimitiveVertex *const v2)
void | invokePointCallbacks (SoAction *const action, const SoPrimitiveVertex *const v)
void | beginShape (SoAction *const action, const TriangleShape shapetype, SoDetail *const detail=NULL)
void | shapeVertex (const SoPrimitiveVertex *const v)
void | endShape (void)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const SbVec3f &normal)
void | generateVertex (SoPrimitiveVertex *const pv, const SbVec3f &point, const SbBool useTexFunc, const SoMultiTextureCoordinateElement *const tce, const float s, const float t, const float r, const SbVec3f &normal)
SbBool | startVertexArray (SoGLRenderAction *action, const SoCoordinateElement *coords, const SbVec3f *pervertexnormals, const SbBool texpervertex, const SbBool colorpervertex)
void | finishVertexArray (SoGLRenderAction *action, const SbBool vbo, const SbBool normpervertex, const SbBool texpervertex, const SbBool colorpervertex)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoShape
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoCylinder class is for rendering cylinder shapes.

Insert a cylinder shape into the scene graph. The cylinder is rendered with the current material, texture and draw style settings (if any, otherwise the default settings are used).

The SoCylinder node class is provided as a convenient abstraction for the application programmer to use "complex" shapes of this type without having to do the tessellation to polygons and other low level programming herself.

A cylinder is visualized by the underlying rendering system by first tessellating the conceptual cylinder into a set of polygons. To control the trade-off between an as much as possible correct visual appearance of the cylinder versus fast rendering, use an SoComplexity node to influence the number of polygons generated from the tessellation process. (The higher the complexity value, the more polygons will be generated, the more rounded the sides of the cylinder will look.) Set the SoComplexity::value field to what you believe would be a good trade-off between correctness and speed for your particular application.

A nice trick for rendering a disc is to render an SoCylinder with SoCylinder::height set to zero:

#Inventor V2.1 ascii
ShapeHints { # to get two-sided lighting on the disc
vertexOrdering COUNTERCLOCKWISE
shapeType UNKNOWN_SHAPE_TYPE
}
Cylinder {
height 0
parts TOP
}
SoCylinder::TOP
@ TOP
Definition SoCylinder.h:52
SoCylinder::parts
SoSFBitMask parts
Definition SoCylinder.h:59
SoCylinder::height
SoSFFloat height
Definition SoCylinder.h:58
SoFieldContainer::get
void get(SbString &fielddata)
Definition SoFieldContainer.cpp:396

FILE FORMAT/DEFAULTS:

Cylinder {
radius 1
height 2
parts (SIDES | TOP | BOTTOM)
}
SoCylinder::BOTTOM
@ BOTTOM
Definition SoCylinder.h:53
SoCylinder::SIDES
@ SIDES
Definition SoCylinder.h:51
SoCylinder::radius
SoSFFloat radius
Definition SoCylinder.h:57

See also
  SoCone, SoSphere, SoCube

## Member Enumeration Documentation

## Part

enum SoCylinder::Part

Enumerates the various parts of the cylinder, for setting inclusion or exclusion from the shape.

Enumerator
SIDES | Sides of cylinder.
TOP | Top of cylinder.
BOTTOM | Bottom of cylinder.
ALL | All parts.

## Constructor & Destructor Documentation

## SoCylinder()

SoCylinder::SoCylinder | ( | void |  | ) |

Constructor.

## ~SoCylinder()

SoCylinder::~SoCylinder | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoCylinder::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoCylinder::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoShape.

## getFieldDataPtr()

const SoFieldData ** SoCylinder::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoCylinder::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoShape.

## initClass()

void SoCylinder::initClass | ( | void |  | ) |

static

## addPart()

void SoCylinder::addPart | ( | SoCylinder::Part | part | ) |

Add a part to the cylinder.

See also
  removePart(), hasPart()

## removePart()

void SoCylinder::removePart | ( | SoCylinder::Part | part | ) |

Remove a part from the cylinder.

See also
  addPart(), hasPart()

## hasPart()

SbBool SoCylinder::hasPart | ( | SoCylinder::Part | part | ) | const

Returns `TRUE` if rendering of the given part is currently turned on.

See also
  addPart(), removePart()

## rayPick()

void SoCylinder::rayPick | ( | SoRayPickAction * | action | ) |

virtual

Calculates picked point based on primitives generated by subclasses.

Reimplemented from SoShape.

## getPrimitiveCount()

void SoCylinder::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) |

virtual

Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

## GLRender()

void SoCylinder::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

## generatePrimitives()

void SoCylinder::generatePrimitives | ( | SoAction * | action | ) |

protected virtual

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

## computeBBox()

void SoCylinder::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center )

protected virtual

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## Member Data Documentation

## radius

SoSFFloat SoCylinder::radius

Radius of cylinder. Default value 1.0.

## height

SoSFFloat SoCylinder::height

Height of cylinder. Default is 2.0.

## parts

SoSFBitMask SoCylinder::parts

Which parts to use for rendering, picking, etc. Defaults to SoCylinder::ALL.

The documentation for this class was generated from the following files:

- SoCylinder.h
- SoCylinder.cpp